@echo off
setlocal enableextensions enabledelayedexpansion || exit /b
(set homeDir=%~dp0) || exit /b

(set manual=1) || exit /b
if "%2" EQU "auto" ( (set manual=0) || exit /b )

call :do_work %1

if errorlevel 1 (
    echo ##################################################################
    echo                      Error detected '%errorlevel%'
    echo ##################################################################

    if "!manual!" EQU "1" pause
    exit /b %errorlevel%
)

exit /b


:do_work
if "%1" EQU "" (
    echo.
    echo Usage:
    echo     %~nx0 ^<target^> [manual^|auto]
    echo.
    exit /b 1
)


REM Date stuff below may not work in your locale :-(

FOR /F "TOKENS=1* DELIMS= " %%A IN ('DATE /T') DO SET CDATE=%%B
FOR /F "TOKENS=1,2 eol=/ DELIMS=/ " %%A IN ('DATE /T') DO SET mm=%%B
FOR /F "TOKENS=1,2 DELIMS=/ eol=/" %%A IN ("%CDATE%") DO SET dd=%%B
FOR /F "TOKENS=2,3 DELIMS=/ " %%A IN ("%CDATE%") DO SET yyyy=%%B
SET date_=%yyyy%-%mm%-%dd%
if errorlevel 1 exit /b

if not exist "%homeDir%logs" md "%homeDir%logs" || exit /b


REM
REM This awesome line below allows us to "tee" output to log file and to detect "%homeDir%%1"s failures
REM unfortunately I did not find a good way to detect errorlevel (it is possible by replacing 'echo' with
REM a call to external batch -- but that call can fail too). Damn, I've spend full day making this single
REM fucking line below... Batch script is dead, it should not have been born.
REM

echo running %homeDir%%1
set error_=0
9>&1 1>&2 2>&9 (for /f "delims=" %%i in ('9^>^&1 1^>^&2 2^>^&9 ^(^(^(2^>^&1 call "%homeDir%%1"^) ^|^| ^(1^>^&2 2^>nul echo FAILED^)^) ^| 2^>nul "%homeDir%mtee" /T /+ "%homeDir%logs\%date_%_%1.log"^)') do (set error_=1))

exit /b %error_%
